package allbricklinkthings;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Iterator;
import java.util.TreeMap;

import javax.swing.JFileChooser;

public class AllBricklionkThings {

	static String findfirst=" <TR BGCOLOR=\"FFFFFF\" CLASS=\"avoidBreak\">";
	static String findsecond="<B>Batch Total:";
	
	public static void main(String[] args) {
		// Get the directory and run the main program
		JFileChooser fc=new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc.showOpenDialog(null);
		File dir=fc.getSelectedFile();
		if(dir==null){System.exit(0);}
		mksummary_db(dir);

	}

	public static void mksummary(File folderpath) {
		try {
			File[] filesinfolder=folderpath.listFiles();
			Arrays.sort(filesinfolder);
			if(filesinfolder.length>0) {
				String summarypath=folderpath.toString()+"/summary.html";
				PrintWriter out=new PrintWriter(new File(summarypath));
				
				for(int i=0;i<filesinfolder.length;i++) {
					if(!filesinfolder[i].toString().endsWith(".html")) {
						BufferedReader in=new BufferedReader(new FileReader(filesinfolder[i]));
						boolean run=true;
						while(run) {
							if(in.readLine().contains(findfirst)){
								run=false;
							}
						}
						run=true;
						while(run) {
							String inline=in.readLine();
							if(inline.contains(findsecond)) {
								out.println(inline.substring(0,inline.indexOf(findsecond)));
								run=false;}
							else {out.println(inline);}
						}
						out.flush();
						in.close();
					}
				}
				out.flush();
				out.close();
			}
		}catch(IOException ee) {}
	}
	
	
	public static void mksummary_v2(File folderpath) {
		try {
			String itembase="/v2/catalog/catalogitem.page?";  //find this to locate items
			String prebase="https://www.bricklink.com";  //base url of Bricklink
			File[] filesinfolder=folderpath.listFiles();
			Arrays.sort(filesinfolder);
			
			if(filesinfolder.length>0) {
				String summarypath=folderpath.toString()+"/summary_test.html";
				PrintWriter out=new PrintWriter(new File(summarypath));
				
				for(int i=0;i<filesinfolder.length;i++) {
					if(!filesinfolder[i].toString().endsWith(".html")) {
						BufferedReader in=new BufferedReader(new FileReader(filesinfolder[i]));
						boolean runfile=true;
						int index=0;
						while(runfile) {
							String inline=in.readLine();
							System.out.println("line read");
							if(inline==null) {runfile=false;}else {
								boolean runline=true;
								int ibaseindex=0;
								int lastibaseindex=-1;
								System.out.println("ibaseindex (should be 0) is "+ibaseindex);
								while(runline) {
									ibaseindex=inline.indexOf(itembase,ibaseindex);
									System.out.println("ibaseindex is "+ibaseindex);
									if(ibaseindex==lastibaseindex) {runline=false;}else{
										int endoflink=inline.indexOf(">", ibaseindex)-1;
										System.out.println("endoflink "+endoflink);
										String link=inline.substring(ibaseindex, endoflink);

										int descstart=endoflink+24;
										System.out.println(inline.length()+" "+descstart);
										int descend=inline.indexOf("<",descstart);
										System.out.println("descend is "+descend);
										out.println(prebase+link);
										if(descend>descstart) {
											String description=inline.substring(descstart,descend);
											out.println(description);
										}
										out.println();
										lastibaseindex=ibaseindex;
										

									}
								}
							}
						}
					}
				}
				
				
				out.flush();
				out.close();
			}
		}catch(IOException ee) {System.err.println(ee);}
	}
	
	public static void mksummary_v3(File folderpath) {
		try {
			String itembase="/v2/catalog/catalogitem.page?";  //find this to locate items
			String prebase="https://www.bricklink.com";  //base url of Bricklink
			File[] filesinfolder=folderpath.listFiles();
			Arrays.sort(filesinfolder);
			
			if(filesinfolder.length>0) {
				String summarypath=folderpath.toString()+"/summary_test.html";
				PrintWriter out=new PrintWriter(new File(summarypath));
				
				for(int i=0;i<filesinfolder.length;i++) {
					if(!filesinfolder[i].toString().endsWith(".html")) {
						BufferedReader in=new BufferedReader(new FileReader(filesinfolder[i]));
						boolean runfile=true;
						int index=0;
						
						//merge the file to one line to avoid unexpected linebreaks in XML
						String filecontent="";
						while(runfile) {
							String inline=in.readLine();
							if(inline==null){runfile=false;}else {
								System.out.println("line read");
								filecontent=filecontent+inline;
							}
						}
						
						//process the content of one file, output a link to Bricklink, description, number, price and total price
						boolean runcontent=true;
						int ibaseindex=0;
						System.out.println("ibaseindex (should be 0) is "+ibaseindex);
						while(runcontent) {
							int newibaseindex=filecontent.indexOf(itembase,ibaseindex);
							System.out.println("newibaseindex is "+newibaseindex);
							if((newibaseindex==ibaseindex)||(newibaseindex<0)) {
									runcontent=false;
									System.out.println(newibaseindex+" "+ibaseindex);
								}else{
								int endoflink=filecontent.indexOf(">", newibaseindex)-1;
								System.out.println("endoflink "+endoflink);
								String link=filecontent.substring(newibaseindex, endoflink);

								int descstart=endoflink+24;
								System.out.println(filecontent.length()+" "+descstart);
								int descend=filecontent.indexOf("</FONT>",descstart);
								System.out.println("descend is "+descend);
								out.println(prebase+link);
								//if(descend>descstart) {
									String description=filecontent.substring(descstart,descend);
									if(description.startsWith("<div")) {
										description=description.substring((description.indexOf("<br>")+4),description.length());
									}
									out.println(description);
								//}
								int numberstart=filecontent.indexOf("bltRightAlign", descend)+15;
								int numberend=filecontent.indexOf("</TD>", numberstart);
								String number=filecontent.substring(numberstart, numberend);
								out.println(number);
								int pricestart=filecontent.indexOf("bltRightAlign", numberend)+15;
								int priceend=filecontent.indexOf("</TD>", pricestart);
								String price=filecontent.substring(pricestart, priceend);
								out.println(price);
								int totalstart=filecontent.indexOf("bltRightAlign", priceend)+15;
								int totalend=filecontent.indexOf("</TD>", totalstart);
								String total=filecontent.substring(totalstart, totalend);
								out.println(total);
								
								out.println();
								ibaseindex=newibaseindex+20; //set it so the same string is not found again
								if(ibaseindex>(filecontent.length()-10)) {runcontent=false;}
							}
						}
						
						
						
					}
				}
				
				
				out.flush();
				out.close();
			}
		}catch(IOException ee) {System.err.println(ee);}
	}

	
	
	public static void mksummary_v4(File folderpath) {
		try {
			String itembase="/v2/catalog/catalogitem.page?";  //find this to locate items
			String prebase="https://www.bricklink.com";  //base url of Bricklink
			File[] filesinfolder=folderpath.listFiles();
			Arrays.sort(filesinfolder);
			
			if(filesinfolder.length>0) {
				String summarypath=folderpath.toString()+"/summary_test.html";
				PrintWriter out=new PrintWriter(new File(summarypath));
				
				for(int i=0;i<filesinfolder.length;i++) {
					if(!filesinfolder[i].toString().endsWith(".html")) {
						BufferedReader in=new BufferedReader(new FileReader(filesinfolder[i]));
						boolean runfile=true;
						int index=0;
						
						//merge the file to one line to avoid unexpected linebreaks in XML
						String filecontent="";
						while(runfile) {
							String inline=in.readLine();
							if(inline==null){runfile=false;}else {
								System.out.println("line read");
								filecontent=filecontent+inline;
							}
						}
						
						//process the content of one file, output a link to Bricklink, description, number, price and total price
						boolean runcontent=true;
						int ibaseindex=0;
						System.out.println("ibaseindex (should be 0) is "+ibaseindex);
						while(runcontent) {
							int newibaseindex=filecontent.indexOf(itembase,ibaseindex);
							System.out.println("newibaseindex is "+newibaseindex);
							if((newibaseindex==ibaseindex)||(newibaseindex<0)) {
									runcontent=false;
									System.out.println(newibaseindex+" "+ibaseindex);
								}else{
								int endoflink=filecontent.indexOf(">", newibaseindex)-1;
								System.out.println("endoflink "+endoflink);
								String link=filecontent.substring(newibaseindex, endoflink);

								int statusstart=filecontent.indexOf("<B>", (newibaseindex-150))+3;
								//System.out.println(filecontent.substring((newibaseindex-150),newibaseindex));
								int statusend=filecontent.indexOf("B>", (statusstart))-2;
								System.out.println(statusstart+" "+statusend);
								String status=filecontent.substring(statusstart, statusend);
								out.println(status);
								
								int descstart=endoflink+24;
								System.out.println(filecontent.length()+" "+descstart);
								int descend=filecontent.indexOf("</FONT>",descstart);
								System.out.println("descend is "+descend);
								out.println(prebase+link);
								//if(descend>descstart) {
									String description=filecontent.substring(descstart,descend);
									if(description.startsWith("<div")) {
										description=description.substring((description.indexOf("<br>")+4),description.length());
									}
									out.println(description);
								//}
								int numberstart=filecontent.indexOf("bltRightAlign", descend)+15;
								int numberend=filecontent.indexOf("</TD>", numberstart);
								String number=filecontent.substring(numberstart, numberend);
								out.println(number);
								int pricestart=filecontent.indexOf("bltRightAlign", numberend)+15;
								int priceend=filecontent.indexOf("</TD>", pricestart);
								String price=filecontent.substring(pricestart, priceend);
								out.println(price);
								int totalstart=filecontent.indexOf("bltRightAlign", priceend)+15;
								int totalend=filecontent.indexOf("</TD>", totalstart);
								String total=filecontent.substring(totalstart, totalend);
								out.println(total);
								
								out.println();
								ibaseindex=newibaseindex+20; //set it so the same string is not found again
								if(ibaseindex>(filecontent.length()-10)) {runcontent=false;}
							}
						}
						
						
						
					}
				}
				
				
				out.flush();
				out.close();
			}
		}catch(IOException ee) {System.err.println(ee);}
	}
	
	
	
	
	
	
	
	public static void mksummary_db(File folderpath) {
		TreeMap<String,LEGOItem> legomap=new TreeMap<String,LEGOItem>((new LEGOStringComparator()));
		try {
			String itembase="/v2/catalog/catalogitem.page?";  //find this to locate items
			String prebase="https://www.bricklink.com";  //base url of Bricklink
			File[] filesinfolder=folderpath.listFiles();
			Arrays.sort(filesinfolder);
			
			if(filesinfolder.length>0) {
				String summarypath=folderpath.toString()+"/summary_test.html";
				//PrintWriter out=new PrintWriter(new File(summarypath));
				
				for(int i=0;i<filesinfolder.length;i++) {
					if(!filesinfolder[i].toString().endsWith(".html")) {
						BufferedReader in=new BufferedReader(new FileReader(filesinfolder[i]));
						//System.out.println(filesinfolder[i]);
						String orderid=filesinfolder[i].toString().substring((filesinfolder[i].toString().lastIndexOf("/"))+1);
						String orderidwin=filesinfolder[i].toString().substring((filesinfolder[i].toString().lastIndexOf("\\"))+1);
						if(orderid.length()>orderidwin.length()) {orderid=orderidwin;}//manage different folder management on windows
						boolean runfile=true;
						int index=0;
						
						//merge the file to one line to avoid unexpected linebreaks in XML
						String filecontent="";
						while(runfile) {
							String inline=in.readLine();
							if(inline==null){runfile=false;}else {
								//System.out.println("line read");
								filecontent=filecontent+inline;
							}
						}
					
						
						
						//process the content of one file, output a link to Bricklink, description, number, price and total price
						boolean runcontent=true;
						int ibaseindex=0;
						//System.out.println("ibaseindex (should be 0) is "+ibaseindex);
						while(runcontent) {
							int newibaseindex=filecontent.indexOf(itembase,ibaseindex);
							//System.out.println("newibaseindex is "+newibaseindex);
							if((newibaseindex==ibaseindex)||(newibaseindex<0)) {
									runcontent=false;
									//System.out.println(newibaseindex+" "+ibaseindex);
								}else{
								int endoflink=filecontent.indexOf(">", newibaseindex)-1;
								//System.out.println("endoflink "+endoflink);
								String link=filecontent.substring(newibaseindex, endoflink);

								//System.out.println(link);
								String identity=link.substring(29);
								//4System.out.println(identity);
								
								int statusstart=filecontent.indexOf("<B>", (newibaseindex-150))+3;
								int statusend=filecontent.indexOf("B>", (statusstart))-2;
								//System.out.println(statusstart+" "+statusend);
								String status=filecontent.substring(statusstart, statusend);
								//out.println(status);
								
								int descstart=endoflink+24;
								//System.out.println(filecontent.length()+" "+descstart);
								int descend=filecontent.indexOf("</FONT>",descstart);
								//System.out.println("descend is "+descend);
								//out.println(prebase+link);
								//if(descend>descstart) {
									String description=filecontent.substring(descstart,descend);
									if(description.startsWith("<div")) {
										description=description.substring((description.indexOf("<br>")+4),description.length());
									}
									//out.println(description);
								//}
								int numberstart=filecontent.indexOf("bltRightAlign", descend)+15;
								int numberend=filecontent.indexOf("</TD>", numberstart);
								String number=filecontent.substring(numberstart, numberend);
								//out.println(number);
								int pricestart=filecontent.indexOf("bltRightAlign", numberend)+15;
								int priceend=filecontent.indexOf("</TD>", pricestart);
								String price=filecontent.substring(pricestart, priceend);
								//out.println(price);
								int totalstart=filecontent.indexOf("bltRightAlign", priceend)+15;
								int totalend=filecontent.indexOf("</TD>", totalstart);
								String total=filecontent.substring(totalstart, totalend);
								//out.println(total);
								
								//out.println();
								ibaseindex=newibaseindex+20; //set it so the same string is not found again
								if(ibaseindex>(filecontent.length()-10)) {runcontent=false;}
								

								
								int num=Integer.parseInt(number);
								boolean isused=false;
								if(status.equalsIgnoreCase("used")){isused=true;}
								
								if(legomap.containsKey(identity)) {
									System.out.println(identity+" is already in Legomap");
									legomap.get(identity).add(orderid,num,isused);
									System.out.println(legomap.size());
								}else {
									System.out.println(identity+" will get an item in Legomap");
									LEGOItem l=new LEGOItem(orderid,identity,num,isused);
									legomap.put(identity, l);
									//System.out.println(legomap.size());
								}
							}
						}
						
						
						
					}
				}
				
				
				
				
				//out.flush();
				//out.close();
				
				
				
				String itempath=folderpath.toString()+"/items.html";
				PrintWriter pw=new PrintWriter(new File(itempath));
				//System.out.println("test");
				System.out.println(legomap.size());
				Iterator<LEGOItem> iter=legomap.values().iterator();
				pw.println("<html><head><title>LEGO from Bricklink</title>");
				pw.println("<style>");
				pw.println("table {");
				pw.println("font-family: arial, sans-serif;");
				pw.println("border-collapse: collapse;");
				pw.println("width: 100%;");
				pw.println("}");

				pw.println("td, th {");
				pw.println("border: 1px solid #dddddd;");
				pw.println("text-align: left;");
				pw.println("padding: 8px;");
				pw.println("}");

				pw.println("tr:nth-child(even) {");
				pw.println("background-color: #dddddd;");
				pw.println("}");
				pw.println("</style>");
				pw.println("</head>");
				pw.println("<body>");
				pw.println("<table>");
				pw.println("<tr><td>ID</td><td>Number of new</td><td>number of used</td><td>Orders containing item</td><tr>");
				while(iter.hasNext()) {
					pw.println(iter.next().toHTML());
				}
				pw.println("</table>");
				pw.println("</body>");
				pw.println("</html>");
				pw.flush();
				pw.close();
				
			}
		}catch(IOException ee) {System.err.println(ee);}
	}
	
	
	
	
	
	
}
