package allbricklinkthings;

import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class LEGOItem implements Comparable<LEGOItem>{

	private TreeSet<String> orders;
	private String ID;
	private int numbernew;
	private int numberused;
	
	
	public LEGOItem(String orderid, String itemID, int units, boolean isused) {
		orders=new TreeSet<String>();
		orders.add(orderid);
		ID=itemID;
		if(isused){numberused=units;numbernew=0;}
		else {numberused=0;numbernew=units;}
	}
	
	public void add(String orderid,int units, boolean isused) {
		orders.add(orderid);
		if(isused){numberused=numberused+units;}
		else {numbernew=numbernew+units;}
	}

	public String getID() {
		return ID;
	}
	
	public int compareTo(LEGOItem other) {
		return ID.compareTo(other.getID());
	}
	
	public String toString() {
		return(ID+"\t"+numbernew+"\t"+numberused+"\t"+getorders());
	}
	
	public String getorders() {
		
		Iterator it=orders.iterator();
		String res="";
		while(it.hasNext()) {
			res=res+", "+((String)(it.next()));
		}
		return res;
	}
	
	
	public String getOrdersAsHTML() {
		Iterator it=orders.iterator();
		String resHTML="";
		while(it.hasNext()) {
			String next=(String)(it.next());
			resHTML=resHTML+" <a href="+next+">"+next+"</a>";
		}
		return resHTML;
	}
	
	public String toHTML(){
		String imID=ID;
		System.out.println("ID: "+ID);
		String type=ID.substring(0,1);
		String imurl="";
		if(imID.contains("&")) {
			imID=imID.substring(0,(imID.indexOf("&")));
			String col=ID.substring(ID.lastIndexOf("=")+1);
			//System.out.println("col: "+col);
			imurl="https://img.bricklink.com/ItemImage/"+type+"N/"+col+"/"+imID.substring(2)+".png";
			//System.out.println("imurl: "+imurl);
		}else {
			StringTokenizer st=new StringTokenizer(imID,"=");
			imurl="https://img.bricklink.com/ItemImage/"+st.nextToken()+"N/0/"+st.nextToken()+".png";
			//System.out.println("imurl: "+imurl);
		}
		String resHTML="<tr><td><IMG BORDER='0'  WIDTH='80' SRC='"+imurl+"'> <a href=https://www.bricklink.com/v2/catalog/catalogitem.page?"+ID+">"+ID+"</a></td><td>"+numbernew+"</td><td>"+numberused+"</td><td>"+getOrdersAsHTML()+"</td></tr>";
		
		return resHTML;
	}
	
}
